<?php
/**
 * Template Name: Photos on a map
 *
 * @package Pluto
 */
?>
<?php get_header(); ?>
<?php if ( have_posts() ) : while ( have_posts() ) : the_post(); ?>
<?php
  $osetin_content_location  = 'left';

  $args = array(
    'post_type' => 'post',
    'posts_per_page' => -1,
    'meta_key' => 'show_a_map',
    'meta_value' => true,
    'meta_query' => array(
      array(
          'key' => 'location_dot',
          'value' => 0,
          'type' => 'NUMERIC',
          'compare' => '>'
      )
    ),
    'tax_query' => array(
      array(
        'taxonomy' => 'post_format',
        'field' => 'slug',
        'terms' => array('post-format-gallery', 'post-format-standard', 'post-format-gallery', 'post-format-image')
      )
    )
  );
  // get results
  $posts_with_location = new WP_Query( $args );

  $dots = array();
  if( $posts_with_location->have_posts() ):
    while ( $posts_with_location->have_posts() ) : $posts_with_location->the_post();
      $gallery_photos_arr = array();
      $gallery_photos = osetin_get_field('gallery_photos');
      if($gallery_photos){
        foreach( $gallery_photos as $image ){
          array_push($gallery_photos_arr, array('thumbnail' => $image['sizes']['thumbnail'], 'full-height' => $image['sizes']['moon-max-size']));
        }
      }
      $post_arr = array('title' => get_the_title(), 'permalink' => get_the_permalink(), 'featured_image' => array('thumbnail' => osetin_output_post_thumbnail_url('thumbnail'), 'full-height' => osetin_output_post_thumbnail_url('moon-max-size')), 'gallery_photos' => $gallery_photos_arr);
      if( osetin_have_rows('location_dot') ){
        while ( osetin_have_rows('location_dot') ) { the_row();
          $location_post = get_sub_field('map_pin');
          $dot_horizontal_coordinate = osetin_get_field('horizontal_coordinate', $location_post->ID);
          $dot_vertical_coordinate = osetin_get_field('vertical_coordinate', $location_post->ID);

          $dot_unique_id = 'dot_'.$location_post->post_title.'_'.$dot_horizontal_coordinate.'_'.$dot_vertical_coordinate;
          $dot_unique_id = preg_replace("/[^0-9a-zA-Z_]/", "", $dot_unique_id);
          if(isset($dots[$dot_unique_id])){
            array_push($dots[$dot_unique_id]['posts'], $post_arr);
            if(empty($post_arr['gallery_photos'])){
              $dots[$dot_unique_id]['total_photos']+= 1;
            }else{
              $dots[$dot_unique_id]['total_photos']+= count($post_arr['gallery_photos']);
            }
          }else{
            $dot = array('x' => $dot_horizontal_coordinate, 'y' => $dot_vertical_coordinate, 'label' => $location_post->post_title, 'posts' => array($post_arr), 'total_photos' => 0);

            if(empty($post_arr['gallery_photos'])){
              $dot['total_photos']+= 1;
            }else{
              $dot['total_photos']+= count($post_arr['gallery_photos']);
            }
            $dots[$dot_unique_id] = $dot;
          }
        }
      }
    endwhile;
  endif;
  wp_reset_query();
  ?>
<?php get_template_part( 'partials/page', 'content-left' ); ?>


<?php
$content_middle_color_scheme = osetin_get_field('content_middle_color_scheme');
$content_middle_bg_color = osetin_get_field('content_middle_bg_color');
$content_middle_hide_btn_css = 'content-middle-hide-icon ';
if(osetin_content_side_has_image('middle')) $content_middle_hide_btn_css.= "with-background ";

$content_middle_css_class = 'content-middle ';
if($content_middle_color_scheme != 'default'){
  $content_middle_css_class.= 'scheme-override scheme-'.$content_middle_color_scheme.' ';
  $content_middle_hide_btn_css.= 'scheme-override scheme-'.$content_middle_color_scheme.' ';
}
$content_middle_style = '';
if($content_middle_bg_color) $content_middle_style.= 'background-color: '.$content_middle_bg_color.';'; ?>

<div class="<?php echo esc_attr($content_middle_css_class); ?>" style="<?php echo esc_attr($content_middle_style); ?>">
  <a href="#" class="<?php echo esc_attr($content_middle_hide_btn_css); ?>"><span></span><span></span><span></span></a>
  <div class="content-middle-sliding-shadow content-middle-sliding-shadow-top" <?php if($content_middle_bg_color) echo 'style="'.osetin_sliding_shadow_top($content_middle_bg_color).'"'; ?>></div>
  <div class="content-middle-sliding-shadow content-middle-sliding-shadow-bottom" <?php if($content_middle_bg_color) echo 'style="'.osetin_sliding_shadow_bottom($content_middle_bg_color).'"'; ?>></div>
  <div class="content-middle-i activate-perfect-scrollbar">
    <div class="content-self">
    <?php
    foreach($dots as $unique_id => $dot){
      if(!$dot['label']) $dot['label'] = __('Not Set', 'moon');
      echo '<h3 id="location_header_'.$unique_id.'" class="underlined">'.$dot['label'].' <div class="details-subtle-heading"><span>'.$dot['total_photos'].'</span> photos</div></h3>';
      echo '<div class="posts-for-location">';
      foreach($dot['posts'] as $post_arr){
          if(empty($post_arr['gallery_photos']) || count($post_arr['gallery_photos']) < 4){
            echo '<div class="post-for-location">';
              echo '<div class="pfl-image full" style="background-image:url('.$post_arr['featured_image']['thumbnail'].');"></div>';
              echo '<a href="'.$post_arr['permalink'].'" class="pfl-title-w"><div class="pfl-icon"><i class="os-icon os-icon-image"></i></div><div class="pfl-title">'.$post_arr['title'].'</div></a>';
            echo '</div>';
          }else{
            echo '<div class="post-for-location with-quarters">';
            for($i=0;$i<4;$i++){
                echo '<div class="pfl-image quarters" style="background-image:url('.$post_arr['gallery_photos'][$i]['thumbnail'].');"></div>';
            }
            echo '<a href="'.$post_arr['permalink'].'" class="pfl-title-w"><div class="pfl-icon"><i class="os-icon os-icon-image"></i></div><div class="pfl-title">'.$post_arr['title'].'</div></a>';
            echo '</div>';
          }
      }
      echo '</div>';
    } ?>
    </div>
  </div>
</div>


<div class="content-right no-padding glued">
  <div class="post-controls pc-top pc-left details-btn-holder">
    <a href="#" class="content-left-show-btn"><i class="os-icon os-icon-bars"></i> <span>show main info</span></a>
  </div>


  <div class="content-right-i activate-perfect-scrollbar">
    <div class="big-dotted-map-box">
      <div class="big-dotted-map-box-i">
        <img src="<?php echo get_template_directory_uri().'/assets/images/dotted-map-black-big.png' ?>" alt="">
        <?php 
        foreach($dots as $unique_id => $dot){ 
          if(isset($dot['x']) && isset($dot['y']) && isset($dot['label'])){ ?>
            <div class="big-map-pin" style="left: <?php echo esc_attr($dot['x']); ?>%; top: <?php echo esc_attr($dot['y']); ?>%;"></div>
            <div class="big-map-label" data-location-id="<?php echo esc_attr($unique_id); ?>" style="left: <?php echo esc_attr($dot['x']); ?>%; top: <?php echo esc_attr($dot['y']); ?>%;"><?php echo $dot['label']; ?></div>
            <?php 
          }
        } 
        ?>
      </div>
    </div>
  </div>
</div>


<?php endwhile; endif; ?>
<?php get_footer(); ?>